//+------------------------------------------------------------------+
//|                                                 rsi with rsi.mq4 |
//|                                                                  |
//| TASC January 2011 Peter Konne article "Combining Rsi With Rsi"   |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_width1  4
#property indicator_width2  4
#property indicator_width3  1
#property indicator_width4  1

//
//
//
//
//

extern int    RsiShort      = 5;
extern int    RsiLong       = 17;
extern int    RsiPrice      = PRICE_CLOSE;
extern double RsiLevelUp    = 60;
extern double RsiLevelDown  = 40;
extern int    MaShortPeriod = 10;
extern int    MaLongPeriod  = 40;
extern int    MaPrice       = PRICE_CLOSE;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = true;
extern bool   alertsEmail        = false;
extern bool   alertsNotification = false;

//
//
//
//
//

double signallUp[];
double signallDn[];
double signalsUp[];
double signalsDn[];
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,signallUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
      SetIndexBuffer(1,signallDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
      SetIndexBuffer(2,signalsUp); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,251);
      SetIndexBuffer(3,signalsDn); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,251);
      SetIndexBuffer(4,trend1);
      SetIndexBuffer(5,trend2);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double range    = iATR(NULL,0,10,i)/2.0;
      double rsiShort = iRSI(NULL,0,RsiShort,RsiPrice,i);
      double rsiLong  = iRSI(NULL,0,RsiLong ,RsiPrice,i);
      double maLong   = iMA(NULL,0,MaLongPeriod ,0,MODE_SMA,MaPrice,i);
      double maShort  = iMA(NULL,0,MaShortPeriod,0,MODE_SMA,MaPrice,i);
      double price    = iMA(NULL,0,1            ,0,MODE_SMA,MaPrice,i);
      
      //
      //
      //
      //
      //
      
         trend1[i] = trend1[i+1]; 
            if (rsiShort>RsiLevelUp)   trend1[i] =  1;
            if (rsiShort<RsiLevelDown) trend1[i] = -1;
         trend2[i] = trend2[i+1]; 
            if (rsiLong>RsiLevelUp)    trend2[i] =  1;
            if (rsiLong<RsiLevelDown)  trend2[i] = -1;

      //
      //
      //
      //
      //
      
      
      signallUp[i] = EMPTY_VALUE;
      signallDn[i] = EMPTY_VALUE;
      signalsUp[i] = EMPTY_VALUE;
      signalsDn[i] = EMPTY_VALUE;
         if (trend1[i]!=trend1[i+1] && trend1[i]== 1 && price > maShort && trend2[i] == -1) signalsUp[i] = Low[i]  - range;  
         if (trend2[i]!=trend2[i+1] && trend2[i]== 1 && price > maLong)                     signallUp[i] = Low[i]  - range*2.0;
         if (trend1[i]!=trend1[i+1] && trend1[i]==-1 && price < maShort && trend2[i] ==  1) signalsDn[i] = High[i] + range;
         if (trend2[i]!=trend2[i+1] && trend2[i]==-1 && price < maLong)                     signallDn[i] = High[i] + range*2.0;
   }      
   manageAlerts();
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
         static string   previousAlert1= "nothing";
         static string   previousAlert2= "nothing";
         static datetime previousTime1 = 0;
         static datetime previousTime2 = 0;
            if (signalsUp[whichBar] !=  EMPTY_VALUE) doAlert(previousAlert1,previousTime1,"first level up");
            if (signalsDn[whichBar] !=  EMPTY_VALUE) doAlert(previousAlert1,previousTime1,"first level down");
            if (signallUp[whichBar] !=  EMPTY_VALUE) doAlert(previousAlert2,previousTime2,"second level up");
            if (signallDn[whichBar] !=  EMPTY_VALUE) doAlert(previousAlert2,previousTime2,"second level down");
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" rsi with rsi signal : "+doWhat;
          if (alertsMessage)      Alert(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol()," rsi with rsi "),message);
          if (alertsNotification) SendNotification(StringConcatenate(Symbol()," rsi with rsi "+message));
          if (alertsSound)        PlaySound("alert2.wav");
   }
}